; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Quaternion VS Matrix44
; Nom du fichier : Quaternion - Test Module.pb
; Version du fichier : 1.0.0
; Programmation : En cours
; Programm par : StarBootics
; Date : 24-09-2012
; Mise  jour : 28-05-2016
; Code PureBasic : 5.42
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

IncludeFile "Vector3 - Module.pb"
IncludeFile "Vector4 - Module.pb"
IncludeFile "Quaternion - Module.pb"
IncludeFile "Matrix44 - Module.pb"

Vector3::DefaultLocalAxis(X_Axis.Vector3::Vector3, Y_Axis.Vector3::Vector3, Z_Axis.Vector3::Vector3)

Quaternion::MakeFromAxisAngle(QuaternionA.Quaternion::Quaternion, X_Axis, Radian(30))
Quaternion::MakeFromAxisAngle(QuaternionB.Quaternion::Quaternion, Y_Axis, Radian(45))
Quaternion::MakeFromAxisAngle(QuaternionC.Quaternion::Quaternion, Z_Axis, Radian(25))

Vector3::Update(Position.Vector3::Vector3, 20.0, 15.0, 3.0)
Vector3::Update(HardPoint00.Vector3::Vector3, 8.660254037844384, 10.000000, -5.0000000)
Vector3::Update(HardPoint01.Vector3::Vector3, -8.660254037844384, 10.000000, -5.0000000)
Vector3::Update(HardPoint02.Vector3::Vector3, 0.000000, 10.000000, 10.0000000)

Quaternion::Product(QuaternionR.Quaternion::Quaternion, QuaternionC, QuaternionB)
Quaternion::Product(QuaternionR, QuaternionR, QuaternionA)
Quaternion::Unit(QuaternionR, QuaternionR)

Quaternion::DirectRotationTranslation(NewHardPoint00.Vector3::Vector3, QuaternionR, Position, HardPoint00)
Quaternion::DirectRotationTranslation(NewHardPoint01.Vector3::Vector3, QuaternionR, Position, HardPoint01)
Quaternion::DirectRotationTranslation(NewHardPoint02.Vector3::Vector3, QuaternionR, Position, HardPoint02)


Matrix44::RotateX(RotationX.Matrix44::Matrix44, Radian(30))
Matrix44::RotateY(RotationY.Matrix44::Matrix44, Radian(45))
Matrix44::RotateZ(RotationZ.Matrix44::Matrix44, Radian(25))


Matrix44::TranslationEx(Trans.Matrix44::Matrix44, Position)
Matrix44::Product(Transform.Matrix44::Matrix44, Trans, RotationZ)
Matrix44::ProductEx(Transform, Transform, RotationY)
Matrix44::ProductEx(Transform, Transform, RotationX)

Matrix44::MakeMatrixFromQuaternion(QuaternionR, RotationMatrix.Matrix44::Matrix44)
Matrix44::ProductEx(RotationMatrix, Trans, RotationMatrix)

Matrix44::ApplyTransformation(Transform, NewHardPoint00x.Vector3::Vector3, HardPoint00)
Matrix44::ApplyTransformation(Transform, NewHardPoint01x.Vector3::Vector3, HardPoint01)
Matrix44::ApplyTransformation(Transform, NewHardPoint02x.Vector3::Vector3, HardPoint02)


Vector3::Minus(Delta00.Vector3::Vector3, NewHardPoint00, NewHardPoint00x)
Vector3::Minus(Delta01.Vector3::Vector3, NewHardPoint01, NewHardPoint01x)
Vector3::Minus(Delta02.Vector3::Vector3, NewHardPoint02, NewHardPoint02x)

Debug "; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<"
Debug "; Quaternion vs Matrix44"
Debug ""

Debug Vector3::Format(NewHardPoint00, 6) + " vs " + Vector3::Format(NewHardPoint00x, 6) + " : " + Str(Vector3::Compare(NewHardPoint00, NewHardPoint00x))
Debug Vector3::Format(NewHardPoint01, 6) + " vs " + Vector3::Format(NewHardPoint01x, 6) + " : " + Str(Vector3::Compare(NewHardPoint01, NewHardPoint01x))
Debug Vector3::Format(NewHardPoint02, 6) + " vs " + Vector3::Format(NewHardPoint02x, 6) + " : " + Str(Vector3::Compare(NewHardPoint02, NewHardPoint02x))

Debug ""
Debug "; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<"
Debug "; Error between Quaternion vs Matrix44 transformation"
Debug ""

Debug Vector3::Format(Delta00, 6)
Debug Vector3::Format(Delta01, 6)
Debug Vector3::Format(Delta02, 6)

Debug ""
Debug "; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<"
Debug "; Matrix from quaterion"
Debug ""

Debug Matrix44::FormatLine1(RotationMatrix, 4)
Debug Matrix44::FormatLine2(RotationMatrix, 4)
Debug Matrix44::FormatLine3(RotationMatrix, 4)
Debug Matrix44::FormatLine4(RotationMatrix, 4)

Debug ""
Debug "; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<"
Debug "; Tranformation Matrix"
Debug ""

Debug Matrix44::FormatLine1(Transform, 4)
Debug Matrix44::FormatLine2(Transform, 4)
Debug Matrix44::FormatLine3(Transform, 4)
Debug Matrix44::FormatLine4(Transform, 4)

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; EnableXP
; CompileSourceDirectory